#include <stdio.h>

int main()
{
    int N,Q,i,j;
    scanf("%d %d", &N, &Q);
    int d[N], p[N];
    for (i=0;i<N;i++)
    {
        scanf("%d %d",&d[i],&p[i]);
    }
    int k[Q];
    for(i=0;i<Q;i++)
    {
        scanf("%d",&k[i]);
    }
    for(j=0;j<Q;j++)
    {
        int m,s=0,dan=0;
        long long int po=0;
        m=k[j];
        for (i = 0; i < N; i++)
        {
            while (dan<=m&&dan<d[i])
            {
                if (s > 0)
                {
                    s--;
                    po++;
                }
                dan++;
            }
            if (d[i]<=m)
            {
                s=s+p[i];
                dan=d[i];
            }
        }
        while (dan<=m)
        {
            if (s>0)
            {
                s--;
                po++;
            }
            dan++;
        }

        printf("%d\n", po);
    }
    return 0;
}